#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <stdarg.h>
#include "SDL.h"
#include "SDL_opengl.h"
#include "physfs.h"

#include "common.h"
#include "texture.h"
#include "sound.h"

int GetRandomNum(int topend)
{
	// returns a number between 0 and topend - 1
	return (rand() % topend);
}

void sys_log(char* message, ...)
{
	va_list args;
	
	va_start(args, message);
	vfprintf(stdout, message, args);
	va_end(args);
	
	return;	
}

void Quit(int code)
{
	sys_log("\nNow exiting. Bye!\n");

	// clear allocated memories
	FreeTextureData();
	QuitSound();
	
	// exit SDL & PhysFS
	PHYSFS_deinit();
	
	// close joysticks!
	/*
	int i;
	for (i = 0; i < SDL_NumJoysticks(); i++)
		if(SDL_JoystickOpened(i))
		    SDL_JoystickClose(joy);
	*/
	SDL_Quit();
	
	// k bye
	exit(code);
}
