#include <stdio.h>
#include <string.h>

#include "SDL.h"
#include "SDL_opengl.h"

#include "common.h"
#include "texture.h"
#include "font.h"


// This is the width of a pixel!
#define BASEWIDTH (1.0f / 1024.0f)


FYDOFONT theFont;

int InitFont()
{
    // Varbles!
    // font widths
    // 					    ,!,",# ,$ ,% ,& ,',(,),*,+,,,-,.,/,0 ,1,2,3 ,4 ,5 ,6 ,7 ,8 ,9 ,:,;,<,=,>,?,@ ,a ,b ,c ,d ,e ,f ,g ,h ,i,j ,k ,l,m ,n ,o ,p ,q ,r ,s,t ,u ,v ,w ,x ,y ,z ,[,\,],^,_,`,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,{,|,},~
    //int charsizes[96] = {4,3,5,7,9,13,10,2,4,4,5,6,3,5,2,5,10,4,10,10,11,9,10,10,10,10,4,4,6,5,6,9,11,9,9,9,9,8,8,10,10,3,8,10,9,11,10,9,8,10,9,9,9,9,9,11,11,11,9,4,5,4,6,6,4,8,8,8,8,8,6,8,8,3,4,9,4,13,8,8,8,8,8,7,6,8,8,13,8,8,7,5,3,5,8};
    int charsizes[96] =   {7,6,6,11,10,13,12,3,7,7,7,6,5,6,4,8,11,6,9,10,11,11,10,11,11,10,4,5,8,9,8,8,15,12,11,11,13,12,11,13,14,5,10,12,9,15,13,13,12,15,12,9,12,12,12,18,13,12,12,9,5,9,8,12,4,10,12,9,11,10,10,11,10,5,9,10,5,16,10,10,12,11,9,9,7,11,10,15,10,11,10,9,2,9,9};
	
	TextureRef temp = GetTexture("gfx/whitefont.tga", 0);
	theFont.texture = temp;
    // Generate array of FYDOFONTCHARS with proper information
    theFont.IntStart = 32;

    double baseWidth = BASEWIDTH;
    double finalHeight;
    finalHeight = 1.0f;
    int currPos = 0;
    int x;

    for (x = 0; x < 96; x++)
    {
        theFont.Char[x].dx = charsizes[x];
        theFont.Char[x].dy = 32.0;
        theFont.Char[x].tx1 = currPos * baseWidth;
        theFont.Char[x].tx2 = ((currPos + charsizes[x]) * baseWidth) + baseWidth;
        theFont.Char[x].ty1 = 0.00;
        theFont.Char[x].ty2 = finalHeight;

        //debug
        //fprintf( stdout, "%f, %f, %f, %f, %f, %f\n", theFont.Char[x].dx, theFont.Char[x].dy, theFont.Char[x].tx1, theFont.Char[x].tx2, theFont.Char[x].ty1, theFont.Char[x].ty2);

        currPos += charsizes[x] + 1;
    }

    // TODO: Build display lists for each character?
    return TRUE;
}

void DrawFontText(char *String, int x, int y, int Wrap)
{
    int Length, i;
    int place = 0;
    FYDOFONTCHAR Char;
	
	// Return if we don't have a valid font 
    if (theFont.IntStart == 0)
        return;

    glBindTexture(GL_TEXTURE_2D, theFont.texture.textureID);

    // Get length of string
    Length = strlen(String);

    glPushMatrix();
       
    //Begin rendering quads
    glBegin(GL_QUADS);

    //Loop through characters
    for (i = 0; i < Length; i++)
    {
        //Get pointer to character
    	int charnum = (int)String[i] - theFont.IntStart;
    	
        Char = theFont.Char[charnum];
        
//        if ((int)String[i] == 42) // meaning of life, universe and everything
//        {
//        	place = 0;
//        	y += 20;
//        }
//        else
//        {
        
	        //Specify vertices and texture coordinates
	        glTexCoord2f(Char.tx2, Char.ty1);
	        glVertex3f(x + place + Char.dx, y, 				0);
	        
	        glTexCoord2f(Char.tx1, Char.ty1);
	        glVertex3f(x + place, 			y, 				0);
	        
	        glTexCoord2f(Char.tx1, Char.ty2);
	        glVertex3f(x + place, 			y + Char.dy, 	0);
	        
	        glTexCoord2f(Char.tx2, Char.ty2);
	        glVertex3f(x + place + Char.dx, y + Char.dy, 	0);
	
	        //Move to next character
	        place += Char.dx + 1;
        
        /*if (Wrap == TRUE && (place > ScreenWidth - 80))
        {
        	place = 0;
        	        	y += 20;
        }*/
//        }
    }

    //Stop rendering quads
    glEnd();

    glPopMatrix();
    
    return;
}
