#ifndef _TEXTURE_H_
#define _TEXTURE_H_

// this uses physfs

typedef struct
{
	// GLubyte will work for images up to 32-bits.
	GLubyte *imageData;
	
	// Stores the color depth of the image in bits
	// per pixel.
	GLuint   bpp;

	GLuint   width;
	GLuint   height;

} Texture;

typedef struct
{
	GLuint textureID; // ID of texture that is loaded into OpenGL already
	char* filename; // For searching purposes

	GLuint   bpp;
	GLuint   width;
	GLuint   height;
	
} TextureRef;

TextureRef	 	*CurrentRefs; // pointer to an array of texturerefs

TextureRef 		GetTexture(const char* filename, int ForceReload);
int 			RemoveTexture(const char* filename);
void 			FreeTextureData();
int 			GetRefsInArray();
int 			GetRefsAllocated();

#endif
